package yrpg.fi.cas.plugin.form;

import kd.bos.bill.BillShowParameter;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.form.FormShowParameter;
import kd.bos.form.ShowType;
import kd.bos.form.events.HyperLinkClickArgs;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.mvc.list.ListView;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.util.StringUtils;
import kd.sdk.plugin.Plugin;

import java.util.HashMap;
import java.util.Map;

/**
 * 付款列表查看源单
 */
public class ShowSrcBillListPlugin extends AbstractListPlugin implements Plugin {
    private final static String NUMBER = "sourcebillnumber";

    @Override
    public void billListHyperLinkClick(HyperLinkClickArgs args) {
        String fieldName = args.getFieldName();
        //判断源单字段
        if (NUMBER.equals(fieldName)) {
            // 超链接点击为编码时取消原逻辑 跳转至自定义页面
            showCustomForm();
            args.setCancel(true);
        }
    }

    private void showCustomForm() {
        ListSelectedRow currentRow = ((ListView) this.getView()).getCurrentSelectedRowInfo();
        BillShowParameter parameter = new BillShowParameter();
        String formId = "";// 自定义表单标识
        Map<String, Object> customParams = new HashMap<>();
        // 传入自定义参数
        Object primaryKeyValue = currentRow.getPrimaryKeyValue();
        DynamicObject casPaybill = BusinessDataServiceHelper.loadSingle(primaryKeyValue, "cas_paybill", "sourcebillnumber,sourcebilltype,sourcebillid");
        if(casPaybill!=null){
            formId = casPaybill.getString("sourcebilltype");
            String srcNum = casPaybill.getString("sourcebillnumber");
            if(!StringUtils.isEmpty(srcNum)){
                QFilter numFilter = new QFilter("billno", QCP.equals,srcNum);
                DynamicObject srcBill = BusinessDataServiceHelper.loadSingle(formId, "id", new QFilter[]{numFilter});
                if(srcBill!=null){
                    parameter.setFormId(formId);
                    parameter.setPkId(srcBill.getPkValue());
                    parameter.setCustomParams(customParams);
                    // 设置打开界面方式
                    parameter.getOpenStyle().setShowType(ShowType.MainNewTabPage);
                    this.getView().showForm(parameter);

                }
            }
        }

    }

}